]> Savannah Git Hosting - gnulib.git/commitdiff
dprintf-gnu: Add tests.
authorBruno Haible <bruno@clisp.org>
Fri, 24 Mar 2023 11:05:26 +0000 (12:05 +0100)
committerBruno Haible <bruno@clisp.org>
Fri, 24 Mar 2023 11:05:26 +0000 (12:05 +0100)
* tests/test-dprintf-gnu.sh: New file, based on
tests/test-dprintf-posix.sh.
* tests/test-dprintf-gnu.c: New file, based on
tests/test-vasnprintf-gnu.c.
* modules/dprintf-gnu-tests: New file, based on
modules/dprintf-posix-tests.

ChangeLog
modules/dprintf-gnu-tests [new file with mode: 0644]
tests/test-dprintf-gnu.c [new file with mode: 0644]
tests/test-dprintf-gnu.sh [new file with mode: 0755]

index 2ae71f5bcf913e72e7da5f02b9d37816aa0de74a..bb0463cba72d918f404ce6804c146c29a87e0e4a 100644 (file)
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,5 +1,13 @@
 2023-03-24  Bruno Haible  <bruno@clisp.org>
 
+       dprintf-gnu: Add tests.
+       * tests/test-dprintf-gnu.sh: New file, based on
+       tests/test-dprintf-posix.sh.
+       * tests/test-dprintf-gnu.c: New file, based on
+       tests/test-vasnprintf-gnu.c.
+       * modules/dprintf-gnu-tests: New file, based on
+       modules/dprintf-posix-tests.
+
        dprintf-gnu: New module.
        * m4/dprintf-posix.m4 (gl_FUNC_DPRINTF_IS_POSIX): New macro,
        extracted from gl_FUNC_DPRINTF_POSIX.
diff --git a/modules/dprintf-gnu-tests b/modules/dprintf-gnu-tests
new file mode 100644 (file)
index 0000000..117e615
--- /dev/null
@@ -0,0 +1,13 @@
+Files:
+tests/test-dprintf-gnu.sh
+tests/test-dprintf-gnu.c
+tests/test-printf-gnu.output
+
+Depends-on:
+dprintf-posix-tests
+
+configure.ac:
+
+Makefile.am:
+TESTS += test-dprintf-gnu.sh
+check_PROGRAMS += test-dprintf-gnu
diff --git a/tests/test-dprintf-gnu.c b/tests/test-dprintf-gnu.c
new file mode 100644 (file)
index 0000000..4ea2b59
--- /dev/null
@@ -0,0 +1,97 @@
+/* Test of POSIX and GNU compatible dprintf() function.
+   Copyright (C) 2007-2023 Free Software Foundation, Inc.
+
+   This program is free software: you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation, either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */
+
+/* Written by Bruno Haible <bruno@clisp.org>, 2023.  */
+
+#include <config.h>
+
+#include <stdio.h>
+
+#include <stddef.h>
+#include <string.h>
+
+#include "macros.h"
+
+static void
+test_function (int (*my_dprintf) (int, const char *, ...))
+{
+  /* Here we don't test output that may be platform dependent.
+     The bulk of the tests is done as part of the 'vasnprintf-posix' module.  */
+
+  /* Test the support of the 'B' conversion specifier for binary output of
+     integers.  */
+
+  /* Zero.  */
+  my_dprintf (fileno (stdout), "%B %d\n", 0, 33, 44, 55);
+
+  /* A positive number.  */
+  my_dprintf (fileno (stdout), "%B %d\n", 12345, 33, 44, 55);
+
+  /* A large positive number.  */
+  my_dprintf (fileno (stdout), "%B %d\n", 0xFFFFFFFEU, 33, 44, 55);
+
+  /* Width.  */
+  my_dprintf (fileno (stdout), "%20B %d\n", 12345, 33, 44, 55);
+
+  /* Width given as argument.  */
+  my_dprintf (fileno (stdout), "%*B %d\n", 20, 12345, 33, 44, 55);
+
+  /* Negative width given as argument (cf. FLAG_LEFT below).  */
+  my_dprintf (fileno (stdout), "%*B %d\n", -20, 12345, 33, 44, 55);
+
+  /* Precision.  */
+  my_dprintf (fileno (stdout), "%.20B %d\n", 12345, 33, 44, 55);
+
+  /* Zero precision and a positive number.  */
+  my_dprintf (fileno (stdout), "%.0B %d\n", 12345, 33, 44, 55);
+
+  /* Zero precision and a zero number.  */
+  my_dprintf (fileno (stdout), "%.0B %d\n", 0, 33, 44, 55);
+
+  /* Width and precision.  */
+  my_dprintf (fileno (stdout), "%25.20B %d\n", 12345, 33, 44, 55);
+
+  /* FLAG_LEFT.  */
+  my_dprintf (fileno (stdout), "%-20B %d\n", 12345, 33, 44, 55);
+
+  /* FLAG_ALT with zero.  */
+  my_dprintf (fileno (stdout), "%#B %d\n", 0, 33, 44, 55);
+
+  /* FLAG_ALT with a positive number.  */
+  my_dprintf (fileno (stdout), "%#B %d\n", 12345, 33, 44, 55);
+
+  /* FLAG_ALT with a positive number and width.  */
+  my_dprintf (fileno (stdout), "%#20B %d\n", 12345, 33, 44, 55);
+
+  /* FLAG_ALT with a positive number and padding.  */
+  my_dprintf (fileno (stdout), "%0#20B %d\n", 12345, 33, 44, 55);
+
+  /* FLAG_ALT with a positive number and precision.  */
+  my_dprintf (fileno (stdout), "%0#.20B %d\n", 12345, 33, 44, 55);
+
+  /* FLAG_ALT with a positive number and width and precision.  */
+  my_dprintf (fileno (stdout), "%#25.20B %d\n", 12345, 33, 44, 55);
+
+  /* FLAG_ALT with a zero precision and a zero number.  */
+  my_dprintf (fileno (stdout), "%#.0B %d\n", 0, 33, 44, 55);
+}
+
+int
+main (int argc, char *argv[])
+{
+  test_function (dprintf);
+  return 0;
+}
diff --git a/tests/test-dprintf-gnu.sh b/tests/test-dprintf-gnu.sh
new file mode 100755 (executable)
index 0000000..8f26654
--- /dev/null
@@ -0,0 +1,16 @@
+#!/bin/sh
+
+tmpfiles=""
+trap 'rm -fr $tmpfiles' HUP INT QUIT TERM
+
+tmpfiles="$tmpfiles t-dprintf-gnu.tmp t-dprintf-gnu.out"
+${CHECKER} ./test-dprintf-gnu${EXEEXT} > t-dprintf-gnu.tmp || exit 1
+LC_ALL=C tr -d '\r' < t-dprintf-gnu.tmp > t-dprintf-gnu.out || exit 1
+
+: "${DIFF=diff}"
+${DIFF} "${srcdir}/test-printf-gnu.output" t-dprintf-gnu.out
+result=$?
+
+rm -fr $tmpfiles
+
+exit $result